<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OTRS_TicketCreate_Ticket StructType
 * Meta informations extracted from the WSDL
 * - documentation: Queue or QueueID is mandatory | State or StateID is mandatory | Priority or PriorityID is mandatory
 * @subpackage Structs
 */
class OTRS_TicketCreate_Ticket extends AbstractStructBase
{
    /**
     * The Title
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Title;
    /**
     * The CustomerUser
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CustomerUser;
    /**
     * The QueueID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $QueueID;
    /**
     * The Queue
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Queue;
    /**
     * The TypeID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $TypeID;
    /**
     * The Type
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Type;
    /**
     * The ServiceID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $ServiceID;
    /**
     * The Service
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Service;
    /**
     * The SLAID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $SLAID;
    /**
     * The SLA
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SLA;
    /**
     * The StateID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $StateID;
    /**
     * The State
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $State;
    /**
     * The PriorityID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $PriorityID;
    /**
     * The Priority
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Priority;
    /**
     * The OwnerID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $OwnerID;
    /**
     * The Owner
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Owner;
    /**
     * The ResponsibleID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $ResponsibleID;
    /**
     * The Responsible
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Responsible;
    /**
     * The CustomerID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CustomerID;
    /**
     * The PendingTime
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OTRS_PendingTime
     */
    public $PendingTime;
    /**
     * Constructor method for OTRS_TicketCreate_Ticket
     * @uses OTRS_TicketCreate_Ticket::setTitle()
     * @uses OTRS_TicketCreate_Ticket::setCustomerUser()
     * @uses OTRS_TicketCreate_Ticket::setQueueID()
     * @uses OTRS_TicketCreate_Ticket::setQueue()
     * @uses OTRS_TicketCreate_Ticket::setTypeID()
     * @uses OTRS_TicketCreate_Ticket::setType()
     * @uses OTRS_TicketCreate_Ticket::setServiceID()
     * @uses OTRS_TicketCreate_Ticket::setService()
     * @uses OTRS_TicketCreate_Ticket::setSLAID()
     * @uses OTRS_TicketCreate_Ticket::setSLA()
     * @uses OTRS_TicketCreate_Ticket::setStateID()
     * @uses OTRS_TicketCreate_Ticket::setState()
     * @uses OTRS_TicketCreate_Ticket::setPriorityID()
     * @uses OTRS_TicketCreate_Ticket::setPriority()
     * @uses OTRS_TicketCreate_Ticket::setOwnerID()
     * @uses OTRS_TicketCreate_Ticket::setOwner()
     * @uses OTRS_TicketCreate_Ticket::setResponsibleID()
     * @uses OTRS_TicketCreate_Ticket::setResponsible()
     * @uses OTRS_TicketCreate_Ticket::setCustomerID()
     * @uses OTRS_TicketCreate_Ticket::setPendingTime()
     * @param string $title
     * @param string $customerUser
     * @param int $queueID
     * @param string $queue
     * @param int $typeID
     * @param string $type
     * @param int $serviceID
     * @param string $service
     * @param int $sLAID
     * @param string $sLA
     * @param int $stateID
     * @param string $state
     * @param int $priorityID
     * @param string $priority
     * @param int $ownerID
     * @param string $owner
     * @param int $responsibleID
     * @param string $responsible
     * @param string $customerID
     * @param \StructType\OTRS_PendingTime $pendingTime
     */
    public function __construct($title = null, $customerUser = null, $queueID = null, $queue = null, $typeID = null, $type = null, $serviceID = null, $service = null, $sLAID = null, $sLA = null, $stateID = null, $state = null, $priorityID = null, $priority = null, $ownerID = null, $owner = null, $responsibleID = null, $responsible = null, $customerID = null, \StructType\OTRS_PendingTime $pendingTime = null)
    {
        $this
            ->setTitle($title)
            ->setCustomerUser($customerUser)
            ->setQueueID($queueID)
            ->setQueue($queue)
            ->setTypeID($typeID)
            ->setType($type)
            ->setServiceID($serviceID)
            ->setService($service)
            ->setSLAID($sLAID)
            ->setSLA($sLA)
            ->setStateID($stateID)
            ->setState($state)
            ->setPriorityID($priorityID)
            ->setPriority($priority)
            ->setOwnerID($ownerID)
            ->setOwner($owner)
            ->setResponsibleID($responsibleID)
            ->setResponsible($responsible)
            ->setCustomerID($customerID)
            ->setPendingTime($pendingTime);
    }
    /**
     * Get Title value
     * @return string
     */
    public function getTitle()
    {
        return $this->Title;
    }
    /**
     * Set Title value
     * @param string $title
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($title)), __LINE__);
        }
        $this->Title = $title;
        return $this;
    }
    /**
     * Get CustomerUser value
     * @return string
     */
    public function getCustomerUser()
    {
        return $this->CustomerUser;
    }
    /**
     * Set CustomerUser value
     * @param string $customerUser
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setCustomerUser($customerUser = null)
    {
        // validation for constraint: string
        if (!is_null($customerUser) && !is_string($customerUser)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($customerUser)), __LINE__);
        }
        $this->CustomerUser = $customerUser;
        return $this;
    }
    /**
     * Get QueueID value
     * @return int|null
     */
    public function getQueueID()
    {
        return $this->QueueID;
    }
    /**
     * Set QueueID value
     * @param int $queueID
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setQueueID($queueID = null)
    {
        // validation for constraint: int
        if (!is_null($queueID) && !is_numeric($queueID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($queueID)), __LINE__);
        }
        $this->QueueID = $queueID;
        return $this;
    }
    /**
     * Get Queue value
     * @return string|null
     */
    public function getQueue()
    {
        return $this->Queue;
    }
    /**
     * Set Queue value
     * @param string $queue
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setQueue($queue = null)
    {
        // validation for constraint: string
        if (!is_null($queue) && !is_string($queue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($queue)), __LINE__);
        }
        $this->Queue = $queue;
        return $this;
    }
    /**
     * Get TypeID value
     * @return int|null
     */
    public function getTypeID()
    {
        return $this->TypeID;
    }
    /**
     * Set TypeID value
     * @param int $typeID
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setTypeID($typeID = null)
    {
        // validation for constraint: int
        if (!is_null($typeID) && !is_numeric($typeID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($typeID)), __LINE__);
        }
        $this->TypeID = $typeID;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($type)), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get ServiceID value
     * @return int|null
     */
    public function getServiceID()
    {
        return $this->ServiceID;
    }
    /**
     * Set ServiceID value
     * @param int $serviceID
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setServiceID($serviceID = null)
    {
        // validation for constraint: int
        if (!is_null($serviceID) && !is_numeric($serviceID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($serviceID)), __LINE__);
        }
        $this->ServiceID = $serviceID;
        return $this;
    }
    /**
     * Get Service value
     * @return string|null
     */
    public function getService()
    {
        return $this->Service;
    }
    /**
     * Set Service value
     * @param string $service
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setService($service = null)
    {
        // validation for constraint: string
        if (!is_null($service) && !is_string($service)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($service)), __LINE__);
        }
        $this->Service = $service;
        return $this;
    }
    /**
     * Get SLAID value
     * @return int|null
     */
    public function getSLAID()
    {
        return $this->SLAID;
    }
    /**
     * Set SLAID value
     * @param int $sLAID
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setSLAID($sLAID = null)
    {
        // validation for constraint: int
        if (!is_null($sLAID) && !is_numeric($sLAID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sLAID)), __LINE__);
        }
        $this->SLAID = $sLAID;
        return $this;
    }
    /**
     * Get SLA value
     * @return string|null
     */
    public function getSLA()
    {
        return $this->SLA;
    }
    /**
     * Set SLA value
     * @param string $sLA
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setSLA($sLA = null)
    {
        // validation for constraint: string
        if (!is_null($sLA) && !is_string($sLA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sLA)), __LINE__);
        }
        $this->SLA = $sLA;
        return $this;
    }
    /**
     * Get StateID value
     * @return int|null
     */
    public function getStateID()
    {
        return $this->StateID;
    }
    /**
     * Set StateID value
     * @param int $stateID
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setStateID($stateID = null)
    {
        // validation for constraint: int
        if (!is_null($stateID) && !is_numeric($stateID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($stateID)), __LINE__);
        }
        $this->StateID = $stateID;
        return $this;
    }
    /**
     * Get State value
     * @return string|null
     */
    public function getState()
    {
        return $this->State;
    }
    /**
     * Set State value
     * @param string $state
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setState($state = null)
    {
        // validation for constraint: string
        if (!is_null($state) && !is_string($state)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($state)), __LINE__);
        }
        $this->State = $state;
        return $this;
    }
    /**
     * Get PriorityID value
     * @return int|null
     */
    public function getPriorityID()
    {
        return $this->PriorityID;
    }
    /**
     * Set PriorityID value
     * @param int $priorityID
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setPriorityID($priorityID = null)
    {
        // validation for constraint: int
        if (!is_null($priorityID) && !is_numeric($priorityID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($priorityID)), __LINE__);
        }
        $this->PriorityID = $priorityID;
        return $this;
    }
    /**
     * Get Priority value
     * @return string|null
     */
    public function getPriority()
    {
        return $this->Priority;
    }
    /**
     * Set Priority value
     * @param string $priority
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setPriority($priority = null)
    {
        // validation for constraint: string
        if (!is_null($priority) && !is_string($priority)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($priority)), __LINE__);
        }
        $this->Priority = $priority;
        return $this;
    }
    /**
     * Get OwnerID value
     * @return int|null
     */
    public function getOwnerID()
    {
        return $this->OwnerID;
    }
    /**
     * Set OwnerID value
     * @param int $ownerID
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setOwnerID($ownerID = null)
    {
        // validation for constraint: int
        if (!is_null($ownerID) && !is_numeric($ownerID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($ownerID)), __LINE__);
        }
        $this->OwnerID = $ownerID;
        return $this;
    }
    /**
     * Get Owner value
     * @return string|null
     */
    public function getOwner()
    {
        return $this->Owner;
    }
    /**
     * Set Owner value
     * @param string $owner
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setOwner($owner = null)
    {
        // validation for constraint: string
        if (!is_null($owner) && !is_string($owner)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($owner)), __LINE__);
        }
        $this->Owner = $owner;
        return $this;
    }
    /**
     * Get ResponsibleID value
     * @return int|null
     */
    public function getResponsibleID()
    {
        return $this->ResponsibleID;
    }
    /**
     * Set ResponsibleID value
     * @param int $responsibleID
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setResponsibleID($responsibleID = null)
    {
        // validation for constraint: int
        if (!is_null($responsibleID) && !is_numeric($responsibleID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($responsibleID)), __LINE__);
        }
        $this->ResponsibleID = $responsibleID;
        return $this;
    }
    /**
     * Get Responsible value
     * @return string|null
     */
    public function getResponsible()
    {
        return $this->Responsible;
    }
    /**
     * Set Responsible value
     * @param string $responsible
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setResponsible($responsible = null)
    {
        // validation for constraint: string
        if (!is_null($responsible) && !is_string($responsible)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($responsible)), __LINE__);
        }
        $this->Responsible = $responsible;
        return $this;
    }
    /**
     * Get CustomerID value
     * @return string|null
     */
    public function getCustomerID()
    {
        return $this->CustomerID;
    }
    /**
     * Set CustomerID value
     * @param string $customerID
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setCustomerID($customerID = null)
    {
        // validation for constraint: string
        if (!is_null($customerID) && !is_string($customerID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($customerID)), __LINE__);
        }
        $this->CustomerID = $customerID;
        return $this;
    }
    /**
     * Get PendingTime value
     * @return \StructType\OTRS_PendingTime|null
     */
    public function getPendingTime()
    {
        return $this->PendingTime;
    }
    /**
     * Set PendingTime value
     * @param \StructType\OTRS_PendingTime $pendingTime
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public function setPendingTime(\StructType\OTRS_PendingTime $pendingTime = null)
    {
        $this->PendingTime = $pendingTime;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OTRS_TicketCreate_Ticket
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
