<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OTRS_TicketHistoryGetResponse_TicketHistoryElement
 * StructType
 * @subpackage Structs
 */
class OTRS_TicketHistoryGetResponse_TicketHistoryElement extends AbstractStructBase
{
    /**
     * The ArticleID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $ArticleID;
    /**
     * The CreateBy
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $CreateBy;
    /**
     * The CreateTime
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CreateTime;
    /**
     * The HistoryType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $HistoryType;
    /**
     * The HistoryTypeID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $HistoryTypeID;
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Name;
    /**
     * The OwnerID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $OwnerID;
    /**
     * The PriorityID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $PriorityID;
    /**
     * The QueueID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $QueueID;
    /**
     * The StateID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $StateID;
    /**
     * The TicketID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $TicketID;
    /**
     * The TypeID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $TypeID;
    /**
     * Constructor method for OTRS_TicketHistoryGetResponse_TicketHistoryElement
     * @uses OTRS_TicketHistoryGetResponse_TicketHistoryElement::setArticleID()
     * @uses OTRS_TicketHistoryGetResponse_TicketHistoryElement::setCreateBy()
     * @uses OTRS_TicketHistoryGetResponse_TicketHistoryElement::setCreateTime()
     * @uses OTRS_TicketHistoryGetResponse_TicketHistoryElement::setHistoryType()
     * @uses OTRS_TicketHistoryGetResponse_TicketHistoryElement::setHistoryTypeID()
     * @uses OTRS_TicketHistoryGetResponse_TicketHistoryElement::setName()
     * @uses OTRS_TicketHistoryGetResponse_TicketHistoryElement::setOwnerID()
     * @uses OTRS_TicketHistoryGetResponse_TicketHistoryElement::setPriorityID()
     * @uses OTRS_TicketHistoryGetResponse_TicketHistoryElement::setQueueID()
     * @uses OTRS_TicketHistoryGetResponse_TicketHistoryElement::setStateID()
     * @uses OTRS_TicketHistoryGetResponse_TicketHistoryElement::setTicketID()
     * @uses OTRS_TicketHistoryGetResponse_TicketHistoryElement::setTypeID()
     * @param int $articleID
     * @param int $createBy
     * @param string $createTime
     * @param string $historyType
     * @param int $historyTypeID
     * @param string $name
     * @param int $ownerID
     * @param int $priorityID
     * @param int $queueID
     * @param int $stateID
     * @param int $ticketID
     * @param int $typeID
     */
    public function __construct($articleID = null, $createBy = null, $createTime = null, $historyType = null, $historyTypeID = null, $name = null, $ownerID = null, $priorityID = null, $queueID = null, $stateID = null, $ticketID = null, $typeID = null)
    {
        $this
            ->setArticleID($articleID)
            ->setCreateBy($createBy)
            ->setCreateTime($createTime)
            ->setHistoryType($historyType)
            ->setHistoryTypeID($historyTypeID)
            ->setName($name)
            ->setOwnerID($ownerID)
            ->setPriorityID($priorityID)
            ->setQueueID($queueID)
            ->setStateID($stateID)
            ->setTicketID($ticketID)
            ->setTypeID($typeID);
    }
    /**
     * Get ArticleID value
     * @return int
     */
    public function getArticleID()
    {
        return $this->ArticleID;
    }
    /**
     * Set ArticleID value
     * @param int $articleID
     * @return \StructType\OTRS_TicketHistoryGetResponse_TicketHistoryElement
     */
    public function setArticleID($articleID = null)
    {
        // validation for constraint: int
        if (!is_null($articleID) && !is_numeric($articleID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($articleID)), __LINE__);
        }
        $this->ArticleID = $articleID;
        return $this;
    }
    /**
     * Get CreateBy value
     * @return int
     */
    public function getCreateBy()
    {
        return $this->CreateBy;
    }
    /**
     * Set CreateBy value
     * @param int $createBy
     * @return \StructType\OTRS_TicketHistoryGetResponse_TicketHistoryElement
     */
    public function setCreateBy($createBy = null)
    {
        // validation for constraint: int
        if (!is_null($createBy) && !is_numeric($createBy)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($createBy)), __LINE__);
        }
        $this->CreateBy = $createBy;
        return $this;
    }
    /**
     * Get CreateTime value
     * @return string
     */
    public function getCreateTime()
    {
        return $this->CreateTime;
    }
    /**
     * Set CreateTime value
     * @param string $createTime
     * @return \StructType\OTRS_TicketHistoryGetResponse_TicketHistoryElement
     */
    public function setCreateTime($createTime = null)
    {
        // validation for constraint: string
        if (!is_null($createTime) && !is_string($createTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($createTime)), __LINE__);
        }
        $this->CreateTime = $createTime;
        return $this;
    }
    /**
     * Get HistoryType value
     * @return string
     */
    public function getHistoryType()
    {
        return $this->HistoryType;
    }
    /**
     * Set HistoryType value
     * @param string $historyType
     * @return \StructType\OTRS_TicketHistoryGetResponse_TicketHistoryElement
     */
    public function setHistoryType($historyType = null)
    {
        // validation for constraint: string
        if (!is_null($historyType) && !is_string($historyType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($historyType)), __LINE__);
        }
        $this->HistoryType = $historyType;
        return $this;
    }
    /**
     * Get HistoryTypeID value
     * @return int
     */
    public function getHistoryTypeID()
    {
        return $this->HistoryTypeID;
    }
    /**
     * Set HistoryTypeID value
     * @param int $historyTypeID
     * @return \StructType\OTRS_TicketHistoryGetResponse_TicketHistoryElement
     */
    public function setHistoryTypeID($historyTypeID = null)
    {
        // validation for constraint: int
        if (!is_null($historyTypeID) && !is_numeric($historyTypeID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($historyTypeID)), __LINE__);
        }
        $this->HistoryTypeID = $historyTypeID;
        return $this;
    }
    /**
     * Get Name value
     * @return string
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\OTRS_TicketHistoryGetResponse_TicketHistoryElement
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get OwnerID value
     * @return int
     */
    public function getOwnerID()
    {
        return $this->OwnerID;
    }
    /**
     * Set OwnerID value
     * @param int $ownerID
     * @return \StructType\OTRS_TicketHistoryGetResponse_TicketHistoryElement
     */
    public function setOwnerID($ownerID = null)
    {
        // validation for constraint: int
        if (!is_null($ownerID) && !is_numeric($ownerID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($ownerID)), __LINE__);
        }
        $this->OwnerID = $ownerID;
        return $this;
    }
    /**
     * Get PriorityID value
     * @return int
     */
    public function getPriorityID()
    {
        return $this->PriorityID;
    }
    /**
     * Set PriorityID value
     * @param int $priorityID
     * @return \StructType\OTRS_TicketHistoryGetResponse_TicketHistoryElement
     */
    public function setPriorityID($priorityID = null)
    {
        // validation for constraint: int
        if (!is_null($priorityID) && !is_numeric($priorityID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($priorityID)), __LINE__);
        }
        $this->PriorityID = $priorityID;
        return $this;
    }
    /**
     * Get QueueID value
     * @return int
     */
    public function getQueueID()
    {
        return $this->QueueID;
    }
    /**
     * Set QueueID value
     * @param int $queueID
     * @return \StructType\OTRS_TicketHistoryGetResponse_TicketHistoryElement
     */
    public function setQueueID($queueID = null)
    {
        // validation for constraint: int
        if (!is_null($queueID) && !is_numeric($queueID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($queueID)), __LINE__);
        }
        $this->QueueID = $queueID;
        return $this;
    }
    /**
     * Get StateID value
     * @return int
     */
    public function getStateID()
    {
        return $this->StateID;
    }
    /**
     * Set StateID value
     * @param int $stateID
     * @return \StructType\OTRS_TicketHistoryGetResponse_TicketHistoryElement
     */
    public function setStateID($stateID = null)
    {
        // validation for constraint: int
        if (!is_null($stateID) && !is_numeric($stateID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($stateID)), __LINE__);
        }
        $this->StateID = $stateID;
        return $this;
    }
    /**
     * Get TicketID value
     * @return int
     */
    public function getTicketID()
    {
        return $this->TicketID;
    }
    /**
     * Set TicketID value
     * @param int $ticketID
     * @return \StructType\OTRS_TicketHistoryGetResponse_TicketHistoryElement
     */
    public function setTicketID($ticketID = null)
    {
        // validation for constraint: int
        if (!is_null($ticketID) && !is_numeric($ticketID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($ticketID)), __LINE__);
        }
        $this->TicketID = $ticketID;
        return $this;
    }
    /**
     * Get TypeID value
     * @return int
     */
    public function getTypeID()
    {
        return $this->TypeID;
    }
    /**
     * Set TypeID value
     * @param int $typeID
     * @return \StructType\OTRS_TicketHistoryGetResponse_TicketHistoryElement
     */
    public function setTypeID($typeID = null)
    {
        // validation for constraint: int
        if (!is_null($typeID) && !is_numeric($typeID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($typeID)), __LINE__);
        }
        $this->TypeID = $typeID;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OTRS_TicketHistoryGetResponse_TicketHistoryElement
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
