<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OTRS_TicketSearch_DynamicField StructType
 * Meta informations extracted from the WSDL
 * - documentation: Empty, Equals, Like, GreaterThan, GreaterThanEquals, SmallerThan or SmallerThanEquals is mandatory
 * @subpackage Structs
 */
class OTRS_TicketSearch_DynamicField extends AbstractStructBase
{
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Name;
    /**
     * The Empty
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Empty;
    /**
     * The Equals
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Equals;
    /**
     * The Like
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Like;
    /**
     * The GreaterThan
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $GreaterThan;
    /**
     * The GreaterThanEquals
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $GreaterThanEquals;
    /**
     * The SmallerThan
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SmallerThan;
    /**
     * The SmallerThanEquals
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SmallerThanEquals;
    /**
     * Constructor method for OTRS_TicketSearch_DynamicField
     * @uses OTRS_TicketSearch_DynamicField::setName()
     * @uses OTRS_TicketSearch_DynamicField::setEmpty()
     * @uses OTRS_TicketSearch_DynamicField::setEquals()
     * @uses OTRS_TicketSearch_DynamicField::setLike()
     * @uses OTRS_TicketSearch_DynamicField::setGreaterThan()
     * @uses OTRS_TicketSearch_DynamicField::setGreaterThanEquals()
     * @uses OTRS_TicketSearch_DynamicField::setSmallerThan()
     * @uses OTRS_TicketSearch_DynamicField::setSmallerThanEquals()
     * @param string $name
     * @param string $empty
     * @param string $equals
     * @param string $like
     * @param string $greaterThan
     * @param string $greaterThanEquals
     * @param string $smallerThan
     * @param string $smallerThanEquals
     */
    public function __construct($name = null, $empty = null, $equals = null, $like = null, $greaterThan = null, $greaterThanEquals = null, $smallerThan = null, $smallerThanEquals = null)
    {
        $this
            ->setName($name)
            ->setEmpty($empty)
            ->setEquals($equals)
            ->setLike($like)
            ->setGreaterThan($greaterThan)
            ->setGreaterThanEquals($greaterThanEquals)
            ->setSmallerThan($smallerThan)
            ->setSmallerThanEquals($smallerThanEquals);
    }
    /**
     * Get Name value
     * @return string
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\OTRS_TicketSearch_DynamicField
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Empty value
     * @return string|null
     */
    public function getEmpty()
    {
        return $this->Empty;
    }
    /**
     * Set Empty value
     * @param string $empty
     * @return \StructType\OTRS_TicketSearch_DynamicField
     */
    public function setEmpty($empty = null)
    {
        // validation for constraint: string
        if (!is_null($empty) && !is_string($empty)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($empty)), __LINE__);
        }
        $this->Empty = $empty;
        return $this;
    }
    /**
     * Get Equals value
     * @return string|null
     */
    public function getEquals()
    {
        return $this->Equals;
    }
    /**
     * Set Equals value
     * @param string $equals
     * @return \StructType\OTRS_TicketSearch_DynamicField
     */
    public function setEquals($equals = null)
    {
        // validation for constraint: string
        if (!is_null($equals) && !is_string($equals)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($equals)), __LINE__);
        }
        $this->Equals = $equals;
        return $this;
    }
    /**
     * Get Like value
     * @return string|null
     */
    public function getLike()
    {
        return $this->Like;
    }
    /**
     * Set Like value
     * @param string $like
     * @return \StructType\OTRS_TicketSearch_DynamicField
     */
    public function setLike($like = null)
    {
        // validation for constraint: string
        if (!is_null($like) && !is_string($like)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($like)), __LINE__);
        }
        $this->Like = $like;
        return $this;
    }
    /**
     * Get GreaterThan value
     * @return string|null
     */
    public function getGreaterThan()
    {
        return $this->GreaterThan;
    }
    /**
     * Set GreaterThan value
     * @param string $greaterThan
     * @return \StructType\OTRS_TicketSearch_DynamicField
     */
    public function setGreaterThan($greaterThan = null)
    {
        // validation for constraint: string
        if (!is_null($greaterThan) && !is_string($greaterThan)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($greaterThan)), __LINE__);
        }
        $this->GreaterThan = $greaterThan;
        return $this;
    }
    /**
     * Get GreaterThanEquals value
     * @return string|null
     */
    public function getGreaterThanEquals()
    {
        return $this->GreaterThanEquals;
    }
    /**
     * Set GreaterThanEquals value
     * @param string $greaterThanEquals
     * @return \StructType\OTRS_TicketSearch_DynamicField
     */
    public function setGreaterThanEquals($greaterThanEquals = null)
    {
        // validation for constraint: string
        if (!is_null($greaterThanEquals) && !is_string($greaterThanEquals)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($greaterThanEquals)), __LINE__);
        }
        $this->GreaterThanEquals = $greaterThanEquals;
        return $this;
    }
    /**
     * Get SmallerThan value
     * @return string|null
     */
    public function getSmallerThan()
    {
        return $this->SmallerThan;
    }
    /**
     * Set SmallerThan value
     * @param string $smallerThan
     * @return \StructType\OTRS_TicketSearch_DynamicField
     */
    public function setSmallerThan($smallerThan = null)
    {
        // validation for constraint: string
        if (!is_null($smallerThan) && !is_string($smallerThan)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($smallerThan)), __LINE__);
        }
        $this->SmallerThan = $smallerThan;
        return $this;
    }
    /**
     * Get SmallerThanEquals value
     * @return string|null
     */
    public function getSmallerThanEquals()
    {
        return $this->SmallerThanEquals;
    }
    /**
     * Set SmallerThanEquals value
     * @param string $smallerThanEquals
     * @return \StructType\OTRS_TicketSearch_DynamicField
     */
    public function setSmallerThanEquals($smallerThanEquals = null)
    {
        // validation for constraint: string
        if (!is_null($smallerThanEquals) && !is_string($smallerThanEquals)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($smallerThanEquals)), __LINE__);
        }
        $this->SmallerThanEquals = $smallerThanEquals;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OTRS_TicketSearch_DynamicField
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
