<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OTRS_TicketSearch_TicketFlag StructType
 * Meta informations extracted from the WSDL
 * - documentation: It should be possible to use other flags in future, rather than just 'Seen'
 * @subpackage Structs
 */
class OTRS_TicketSearch_TicketFlag extends AbstractStructBase
{
    /**
     * The Seen
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Seen;
    /**
     * Constructor method for OTRS_TicketSearch_TicketFlag
     * @uses OTRS_TicketSearch_TicketFlag::setSeen()
     * @param int $seen
     */
    public function __construct($seen = null)
    {
        $this
            ->setSeen($seen);
    }
    /**
     * Get Seen value
     * @return int|null
     */
    public function getSeen()
    {
        return $this->Seen;
    }
    /**
     * Set Seen value
     * @param int $seen
     * @return \StructType\OTRS_TicketSearch_TicketFlag
     */
    public function setSeen($seen = null)
    {
        // validation for constraint: int
        if (!is_null($seen) && !is_numeric($seen)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($seen)), __LINE__);
        }
        $this->Seen = $seen;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OTRS_TicketSearch_TicketFlag
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
