<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TicketHistoryGetResponse StructType
 * @subpackage Structs
 */
class TicketHistoryGetResponse extends AbstractStructBase
{
    /**
     * The TicketHistory
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \StructType\OTRS_TicketHistoryGetResponse_TicketHistory[]
     */
    public $TicketHistory;
    /**
     * Constructor method for TicketHistoryGetResponse
     * @uses TicketHistoryGetResponse::setTicketHistory()
     * @param \StructType\OTRS_TicketHistoryGetResponse_TicketHistory[] $ticketHistory
     */
    public function __construct(array $ticketHistory = array())
    {
        $this
            ->setTicketHistory($ticketHistory);
    }
    /**
     * Get TicketHistory value
     * @return \StructType\OTRS_TicketHistoryGetResponse_TicketHistory[]
     */
    public function getTicketHistory()
    {
        return $this->TicketHistory;
    }
    /**
     * Set TicketHistory value
     * @throws \InvalidArgumentException
     * @param \StructType\OTRS_TicketHistoryGetResponse_TicketHistory[] $ticketHistory
     * @return \StructType\TicketHistoryGetResponse
     */
    public function setTicketHistory(array $ticketHistory = array())
    {
        foreach ($ticketHistory as $ticketHistoryGetResponseTicketHistoryItem) {
            // validation for constraint: itemType
            if (!$ticketHistoryGetResponseTicketHistoryItem instanceof \StructType\OTRS_TicketHistoryGetResponse_TicketHistory) {
                throw new \InvalidArgumentException(sprintf('The TicketHistory property can only contain items of \StructType\OTRS_TicketHistoryGetResponse_TicketHistory, "%s" given', is_object($ticketHistoryGetResponseTicketHistoryItem) ? get_class($ticketHistoryGetResponseTicketHistoryItem) : gettype($ticketHistoryGetResponseTicketHistoryItem)), __LINE__);
            }
        }
        $this->TicketHistory = $ticketHistory;
        return $this;
    }
    /**
     * Add item to TicketHistory value
     * @throws \InvalidArgumentException
     * @param \StructType\OTRS_TicketHistoryGetResponse_TicketHistory $item
     * @return \StructType\TicketHistoryGetResponse
     */
    public function addToTicketHistory(\StructType\OTRS_TicketHistoryGetResponse_TicketHistory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OTRS_TicketHistoryGetResponse_TicketHistory) {
            throw new \InvalidArgumentException(sprintf('The TicketHistory property can only contain items of \StructType\OTRS_TicketHistoryGetResponse_TicketHistory, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TicketHistory[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TicketHistoryGetResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
